libname mylib "C:\Users\Dipankar\Desktop\NLMIXED\";

data fish;
   set mylib.fish;
run;

proc print data = fish;
run;



*zero inflated poisson, producing the same result as "zip count child camper persons, inflate(child)" in Stata;
proc nlmixed data=fish;
   parameters b0=0 b1=0 b2=0 b3 = 0
              a0=0 a1 = 0 ;
   /* linear predictor for the inflation probability      */
   linpinfl = a0 + a1*child;
   /* infprob = inflation probability for zeros           */
   /*         = logistic transform of the linear predictor*/
   infprob  = 1/(1+exp(-linpinfl));
   /* Poisson mean */
   lambda   = exp(b0 + b1*child + b2*camper + b3*persons );
   /* Build the ZIP log likelihood */
   if count=0 then 
        ll = log(infprob + (1-infprob)*exp(-lambda));
   else ll = log((1-infprob)) - lambda  + count*log(lambda) - lgamma(count + 1);
   model count ~ general(ll);
run;
         


*zero inflated negative binomial, producing the same result as "zinb count child camper persons, inflate(child)" in Stata;;
proc nlmixed data=fish ;
   parameters b0=0 b1=0 b2=0 b3 = 0
              a0=0 a1 = 0 alpha = 1;
   /* linear predictor for the inflation probability      */
   linpinfl = a0 + a1*child;
   /* infprob = inflation probability for zeros           */
   /*         = logistic transform of the linear predictor*/
   infprob  = 1/(1+exp(-linpinfl));
   /* negative binomial with mean-dispersion */
   lambda   = exp(b0 + b1*child + b2*camper + b3*persons );
   /* Build the ZIP log likelihood */
   m = 1/alpha;
   p = 1/(1+alpha*lambda);
   if count=0 then 
        ll = log(infprob + (1-infprob)*(p**m));
   else ll = log(1-infprob) + log(gamma(m + count)) - log(gamma(count + 1))
   			 - log(gamma(m)) + m*log(p) + count*log(1-p);
   model count ~ general(ll);

run;

